#!/usr/bin/perl -w

#y $enctype = "-e aes256-cbc-hmac-sha1-96:normal";
my $enctype = "-e des3-cbc-sha1:normal";

my $keyfiledir = "/root/krb5-hostkeys";
-d $keyfiledir or mkdir $keyfiledir;

############################################################
use POSIX;
 
@ARGV or ( print "usage: hostkey_generator.pl <ip-range>\n" and exit );

$domainname = `hostname -d`;
chomp $domainname;
$domainname or die "Failed to retrieve domainname";

$addresses = join " ", @ARGV;
print STDERR "Generating krb5 hostkeys for $addresses\n";
open SCAN , "nmap -sP $addresses 2>/dev/null |" or die "Unable to start nmap: $!";

%hostlist = ();
while (<SCAN>){
  /Host ([\w\.]+) \((\d+.\d+.\d+.\d+)\)/ and $hostlist{$1} = $2;
}
close SCAN;

foreach $host (sort (keys %hostlist)){
  $host =~ /$domainname/ or (warn  "$host is not a supported host" and next);
  
  if( ! -f "$keyfiledir/$host" ){
    my $princ = "host/$host";
    my $kadmin = `/usr/sbin/kadmin -p ank/admin -k -t /etc/krb5.keytab.ank -q "getprinc $princ" 2>&1`;
    "$?" >> 8 and die "Unable to execute kadmin: ", $kadmin, "," , $? >> 8;
    if($kadmin =~ /Principal does not exist/){
      system ("/usr/sbin/kadmin",
	      "-p", "ank/admin", "-k",  "-t",  "/etc/krb5.keytab.ank",
	      "-q", "addprinc -pw qwertzuiop $enctype +allow_tix $princ");
	      
      system ("/usr/sbin/kadmin",
	      "-p", "cpw/admin", "-k",  "-t",  "/etc/krb5.keytab.cpw",
	      "-q", "cpw -randkey $enctype $princ");
      
      $kadmin = `/usr/sbin/kadmin -p ank/admin -k -t /etc/krb5.keytab.ank -q "getprinc $princ" 2>&1 `;
      if($kadmin =~ /Principal does not exist/){
	print STDERR "ERROR: Failed to create principal for $princ\n";
	exit 1;
      }
    }
    system ("/usr/sbin/kadmin",
	    "-p", "cpw/admin", "-k", "-t", "/etc/krb5.keytab.cpw",
	    "-q", "ktadd -k $keyfiledir/$host $enctype $princ");
  }
  system("scp",  "$keyfiledir/$host",  "$host:/etc/krb5.keytab");
}
